import objectdraw.*;
import java.awt.*;

/*
 * Example NestedSquaresDrag: draw a nested squares object,
 * drag it around.
 *
 * Jim Teresco, The College of Saint Rose, CSC 252, Fall 2013
 *
 * $Id: NestedSquaresDrag.java 2572 2015-03-12 01:41:39Z terescoj $
 */

public class NestedSquaresDrag extends WindowController {
   
    // standard dragging stuff: nothing here hints at recursion
    private NestedSquares theSquares;
    private boolean dragging;
    private Location lastMouse;
   
    public void begin() {
    
        theSquares = new NestedSquares(100, 100, 100, canvas);
    }
    
    public void onMousePress(Location point) {

        if (theSquares.contains(point)) {
            dragging = true;
            lastMouse = point;
        }
    }
    
    public void onMouseDrag(Location point) {
        
        if (dragging) {
            theSquares.move(point.getX() - lastMouse.getX(),
                            point.getY() - lastMouse.getY());
            lastMouse = point;
        }
    }
    
    public void onMouseRelease(Location point) {
        
        dragging = false;
    }
}
